\section{Introduction}
\label{sec:introduction}

All programming languages let us translate our ideas into machine code so it
can be executed. Nevertheless not all share the same level of abstraction from
the underlying machine working principles. Higher abstraction levels lead to
faster development and simplicity, but lower abstraction levels allow better
efficiency through optimization of the used resources.

Efficiency is a key factor in the development of software that is intended to
process data in real time. Which is fundamental in many fields, such as Mobile
Robots Localization. It is because of this that the authors of this work
proposed a C++ learning project for the \emph{Computer Science: Exercises}
course. 

This work implements a cross-platform User Interface written in C++
for visualization and analyzing video images and sound. The UI contains:
\begin{itemize}
    \item A widget that can display native OpenCV images.
    \item Video file selector that prompts the OS for a file path that matches
    the available formats.
    \item Reproduction controls: Timeline, play/stop button, forward and
    backwards buttons, reproduction speed slider.
    \item Image processing options (e.g.,  Blur).
    \item Audio processing options (e.g., Mel Frequency Cepstrum Coefficients).
\end{itemize}

\autoref{sec:related-work} describes the works on which our project depends as
well as similar projects that have served as inspiration.
\autoref{sec:overview} explains the implementation of our work.
\autoref{sec:evaluation} shows the results of our implementation and
\autoref{sec:conclusion} enumerates what we learnt during the development as
well as challenges that still need to be faced.
